"use strict";
// (See ./evalCodeTutorial.md for information)
Object.defineProperty(exports, "__esModule", { value: true });
// Our mission will be developing a TypeScript "plugin" that will toggle the string literals inside user's 
// selection, from double to simple quotes and viceversa. This is not a TLS
// The following statements are sample code that we will use for testing our plugin
const firstString = "I'm a literal string and \"you will try to change\" my quotes";
function evaluateMe() {
    const position = 379;
    const project = new c.SimpleProjectConstructor();
    const sourceFile = c.project.createSourceFile('tmp/tmp_sourcefile_' + new Date().getTime() + '.ts', c.node.getSourceFile().getFullText());
    const node = sourceFile.getDescendantAtPos(position);
    const inferReturnType = (decl) => {
        const tmpSourceFile = project.createSourceFile('tmp2.ts', decl.getText() + '; const tmp = ' + decl.getName() + '()');
        const tmpDecl = tmpSourceFile.getDescendantsOfKind(ts.SyntaxKind.FunctionDeclaration)[0];
        const typeargs = tmpDecl.getReturnType().getTypeArguments();
        tmpDecl.removeReturnType();
        const tmp = tmpSourceFile.getFirstDescendantByKind(ts.SyntaxKind.VariableDeclaration);
        const type = project.getTypeChecker().getTypeAtLocation(tmp);
        print('tp: ' + tmp.getText() + 'ssss+***' + type.getText());
        const intStructure = {
            name: decl.getReturnTypeNode().getText(),
            properties: type.getProperties()
                .filter(p => { const v = p.getValueDeclaration(); return TypeGuards.isPropertyAssignment(v) && !v.getInitializer().getKindName().includes('Function'); })
                .map(p => ({
                name: p.getName(),
                type: project.getTypeChecker().getTypeAtLocation(p.getValueDeclaration()).getText(),
                val: p.getValueDeclaration()
            })),
            methods: type.getProperties()
                .filter(p => {
                const v = p.getValueDeclaration();
                return TypeGuards.isPropertyAssignment(v) && v.getInitializer().getKindName().includes('Function');
            })
                .map(p => {
                const v = p.getValueDeclaration();
                if (!TypeGuards.isPropertyAssignment(v)) {
                    return [];
                }
                const init = v.getInitializer();
                if (!TypeGuards.isArrowFunction(init) && !TypeGuards.isFunctionExpression(init)) {
                    return [];
                }
                return {
                    name: p.getName(),
                    returnType: init.getReturnType() ? init.getReturnType().getText() : 'any',
                    parameters: init.getParameters().map(pa => ({
                        name: pa.getName(),
                        type: pa.getType().getText()
                    }))
                };
            }),
            typeParameters: typeargs.map(ta => ({
                name: ta.getSymbol().getName()
            })),
        };
        tmpSourceFile.delete();
        return intStructure;
    };
    const decl = node.getFirstAncestorByKind(ts.SyntaxKind.FunctionDeclaration);
    const intStruct = inferReturnType(decl);
    sourceFile.addInterface(intStruct);
    print(sourceFile.getText());
    sourceFile.deleteImmediatelySync();
}
